
# 1 "Data_Detector.c"

# 18 "C:\Program Files (x86)\Flowcode\Compilers\picv2\pic\include\xc.h"
extern const char __xc8_OPTIM_SPEED;

extern double __fpnormalize(double);


# 13 "C:\Program Files (x86)\Flowcode\Compilers\picv2\pic\include\c90\xc8debug.h"
#pragma intrinsic(__builtin_software_breakpoint)
extern void __builtin_software_breakpoint(void);

# 52 "C:\Program Files (x86)\Flowcode\Compilers\picv2\pic\include\pic12f509.h"
extern volatile unsigned char INDF __at(0x000);

asm("INDF equ 00h");


typedef union {
struct {
unsigned INDF :8;
};
} INDFbits_t;
extern volatile INDFbits_t INDFbits __at(0x000);

# 72
extern volatile unsigned char TMR0 __at(0x001);

asm("TMR0 equ 01h");


typedef union {
struct {
unsigned TMR0 :8;
};
} TMR0bits_t;
extern volatile TMR0bits_t TMR0bits __at(0x001);

# 92
extern volatile unsigned char PCL __at(0x002);

asm("PCL equ 02h");


typedef union {
struct {
unsigned PCL :8;
};
} PCLbits_t;
extern volatile PCLbits_t PCLbits __at(0x002);

# 112
extern volatile unsigned char STATUS __at(0x003);

asm("STATUS equ 03h");


typedef union {
struct {
unsigned C :1;
unsigned DC :1;
unsigned Z :1;
unsigned nPD :1;
unsigned nTO :1;
unsigned PA0 :1;
unsigned :1;
unsigned GPWUF :1;
};
struct {
unsigned CARRY :1;
unsigned :1;
unsigned ZERO :1;
};
} STATUSbits_t;
extern volatile STATUSbits_t STATUSbits __at(0x003);

# 184
extern volatile unsigned char FSR __at(0x004);

asm("FSR equ 04h");


typedef union {
struct {
unsigned FSR :8;
};
} FSRbits_t;
extern volatile FSRbits_t FSRbits __at(0x004);

# 204
extern volatile unsigned char OSCCAL __at(0x005);

asm("OSCCAL equ 05h");


typedef union {
struct {
unsigned :1;
unsigned CAL :7;
};
struct {
unsigned :1;
unsigned CAL0 :1;
unsigned CAL1 :1;
unsigned CAL2 :1;
unsigned CAL3 :1;
unsigned CAL4 :1;
unsigned CAL5 :1;
unsigned CAL6 :1;
};
} OSCCALbits_t;
extern volatile OSCCALbits_t OSCCALbits __at(0x005);

# 270
extern volatile unsigned char GPIO __at(0x006);

asm("GPIO equ 06h");


typedef union {
struct {
unsigned GP0 :1;
unsigned GP1 :1;
unsigned GP2 :1;
unsigned GP3 :1;
unsigned GP4 :1;
unsigned GP5 :1;
};
} GPIObits_t;
extern volatile GPIObits_t GPIObits __at(0x006);

# 320
extern volatile __control unsigned char OPTION __at(0x000);



extern volatile __control unsigned char TRIS __at(0x006);



extern volatile __control unsigned char TRISGPIO __at(0x006);

# 351
extern volatile __bit CAL0 __at(0x29);


extern volatile __bit CAL1 __at(0x2A);


extern volatile __bit CAL2 __at(0x2B);


extern volatile __bit CAL3 __at(0x2C);


extern volatile __bit CAL4 __at(0x2D);


extern volatile __bit CAL5 __at(0x2E);


extern volatile __bit CAL6 __at(0x2F);


extern volatile __bit CARRY __at(0x18);


extern volatile __bit DC __at(0x19);


extern volatile __bit GP0 __at(0x30);


extern volatile __bit GP1 __at(0x31);


extern volatile __bit GP2 __at(0x32);


extern volatile __bit GP3 __at(0x33);


extern volatile __bit GP4 __at(0x34);


extern volatile __bit GP5 __at(0x35);


extern volatile __bit GPWUF __at(0x1F);


extern volatile __bit PA0 __at(0x1D);


extern volatile __bit ZERO __at(0x1A);


extern volatile __bit nPD __at(0x1B);


extern volatile __bit nTO __at(0x1C);


# 30 "C:\Program Files (x86)\Flowcode\Compilers\picv2\pic\include\pic.h"
#pragma intrinsic(__nop)
extern void __nop(void);

# 78
__attribute__((__unsupported__("The " "FLASH_READ" " macro function is no longer supported. Please use the MPLAB X MCC."))) unsigned char __flash_read(unsigned short addr);

__attribute__((__unsupported__("The " "FLASH_WRITE" " macro function is no longer supported. Please use the MPLAB X MCC."))) void __flash_write(unsigned short addr, unsigned short data);

__attribute__((__unsupported__("The " "FLASH_ERASE" " macro function is no longer supported. Please use the MPLAB X MCC."))) void __flash_erase(unsigned short addr);


# 91
#pragma intrinsic(_delay)
extern __nonreentrant void _delay(unsigned long);
#pragma intrinsic(_delaywdt)
extern __nonreentrant void _delaywdt(unsigned long);

# 137
extern __bank0 unsigned char __resetbits;
extern __bank0 __bit __powerdown;
extern __bank0 __bit __timeout;

# 30 "C:\Program Files (x86)\Flowcode\Compilers\picv2\pic\include\c90\math.h"
extern double fabs(double);
extern double floor(double);
extern double ceil(double);
extern double modf(double, double *);
extern double sqrt(double);
extern double atof(const char *);
extern double sin(double) __attribute__((unsupported("function \"" "sin" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double cos(double) __attribute__((unsupported("function \"" "cos" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double tan(double) __attribute__((unsupported("function \"" "tan" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double asin(double) __attribute__((unsupported("function \"" "asin" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double acos(double) __attribute__((unsupported("function \"" "acos" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double atan(double);
extern double atan2(double, double) __attribute__((unsupported("function \"" "atan2" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double log(double);
extern double log10(double);
extern double pow(double, double) __attribute__((unsupported("function \"" "pow" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double exp(double) __attribute__((unsupported("function \"" "exp" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double sinh(double) __attribute__((unsupported("function \"" "sinh" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double cosh(double) __attribute__((unsupported("function \"" "cosh" "\" is not supported by this device. Its minimum memory usage exceeds the maximum available")));;
extern double tanh(double);
extern double eval_poly(double, const double *, int);
extern double frexp(double, int *);
extern double ldexp(double, int);
extern double fmod(double, double);
extern double trunc(double);
extern double round(double);

# 34 "Data_Detector.c"
__config("__PROG_CONFIG", "pic", 0x1, 0x3FEA);

# 46 "C:\ProgramData\MatrixTSL\FlowcodeV10\CAL\PIC\PIC_CAL_TypeDefs.c"
typedef signed char MX_SINT8;
typedef signed short MX_SINT16;
typedef signed long MX_SINT32;
typedef unsigned char MX_UINT8;
typedef unsigned short MX_UINT16;
typedef unsigned long MX_UINT32;
typedef char MX_CHAR;
typedef MX_UINT16 MX_UINT;
typedef MX_SINT16 MX_SINT;




typedef MX_UINT8 MX_BOOL;


typedef float MX_FLOAT;




typedef union
{
MX_UINT32 AsLong;
MX_UINT16 AsInt[2];
MX_UINT8 AsByte[4];
} MX_Union32;

typedef union
{
MX_UINT16 AsInt;
MX_UINT8 AsByte[2];
} MX_Union16;

# 49 "C:\ProgramData\MatrixTSL\FlowcodeV10\CAL\PIC\PIC_CAL_IO.c"
MX_UINT8 tvar = 255;

void FC_CAL_Port_Out_DDR_10F_x (MX_UINT8 OutMask, MX_UINT8 OutValue)
{
tvar = tvar & (~OutMask);
asm("movf(_tvar),w");
asm("TRIS 6");

GPIO = (GPIO & ~OutMask) | (OutValue & OutMask);
}

inline MX_UINT8 FC_CAL_Port_In_DDR_10F_x (MX_UINT8 InMask, MX_UINT8 Shift)
{
tvar = tvar | InMask;
asm("movf(_tvar),w");
asm("TRIS 6");

return (GPIO & InMask) >> Shift;
}

# 44 "C:\ProgramData\MatrixTSL\FlowcodeV10\CAL\PIC\PIC_CAL_Delay.c"
void Wdt_Delay_S(MX_UINT8 delay);
void Wdt_Delay_Ms(MX_UINT8 delay);

# 57
void FCI_DELAYINT_US(MX_UINT16 Delay);

void FCI_DELAYINT_MS(MX_UINT16 Delay);
void FCI_DELAYINTWDT_MS(MX_UINT16 Delay);

void FCI_DELAYINT_S(MX_UINT16 Delay);
void FCI_DELAYINTWDT_S(MX_UINT16 Delay);




void delay_10us(MX_UINT8 del);
void delay_us(MX_UINT8 del);
void delay_ms(MX_UINT8 del);
void delay_s(MX_UINT8 del);



void delay_10us(MX_UINT8 del)
{
while (del--)
{
_delay((unsigned long)((10)*(4000000/4000000.0)));
}
}



void delay_us(MX_UINT8 del)
{
while (del > 99)
{
_delay((unsigned long)((100)*(4000000/4000000.0)));
del -= 100;
}
while (del > 9)
{
_delay((unsigned long)((10)*(4000000/4000000.0)));
del -= 10;
}
while (del--)
{
_delay((unsigned long)((1)*(4000000/4000000.0)));
}
}



void delay_ms(MX_UINT8 del)
{
while (del--)
{
_delay((unsigned long)((1)*(4000000/4000.0)));
}
}


void delay_s(MX_UINT8 del)
{
MX_UINT8 i;
for(i=0; i<del; i++)
{
delay_ms(250);
delay_ms(250);
delay_ms(250);
delay_ms(250);
}
}



void Wdt_Delay_S(MX_UINT8 delay)
{
MX_UINT8 i;
MX_UINT16 j;
for (i=0; i<delay; i++)
{
for (j=0; j<999; j++)
{
Wdt_Delay_Ms(1);
}
}
}

void Wdt_Delay_Ms(MX_UINT8 delay)
{
MX_UINT8 i;
for (i=0; i<delay; i++)
{
asm("clrwdt");
delay_ms(1);
}
}


void FCI_DELAYINT_US(MX_UINT16 Delay)
{
while (Delay > 255)
{
delay_us(255);
Delay = Delay - 255;
}
if (Delay > 0)
delay_us(Delay & 0xFF);
}

void FCI_DELAYINT_MS(MX_UINT16 Delay)
{
while (Delay > 255)
{
delay_ms(255);
Delay = Delay - 255;
}
if (Delay > 0)
delay_ms(Delay & 0xFF);
}

void FCI_DELAYINTWDT_MS(MX_UINT16 Delay)
{
while (Delay > 255)
{
Wdt_Delay_Ms(255);
Delay = Delay - 255;
}
if (Delay > 0)
Wdt_Delay_Ms(Delay & 0xFF);
}

void FCI_DELAYINT_S(MX_UINT16 Delay)
{
while (Delay > 255)
{
delay_s(255);
Delay = Delay - 255;
}
if (Delay > 0)
delay_s(Delay & 0xFF);
}

void FCI_DELAYINTWDT_S(MX_UINT16 Delay)
{
while (Delay > 255)
{
Wdt_Delay_S(255);
Delay = Delay - 255;
}
if (Delay > 0)
Wdt_Delay_S(Delay & 0xFF);
}

# 93 "C:\ProgramData\MatrixTSL\FlowcodeV10\CAL\PIC\PIC_CAL_String.c"
MX_UINT8 FCI_GETCHAR(unsigned char* sStr1, MX_UINT16 iStr1_len, MX_UINT16 iPos);
MX_UINT16 FCI_GETLENGTH(unsigned char* sStr1, MX_UINT16 iStr1_len);
unsigned char* FCI_MIDSTRING(unsigned char* sSrc, MX_UINT16 iSrc_len, MX_UINT16 iStart, MX_UINT16 iCount, unsigned char* sDst, MX_UINT16 iDst_len);
unsigned char* FCI_LEFTSTRING(unsigned char* sSrc, MX_UINT16 iSrc_len, MX_UINT16 iCount, unsigned char* sDst, MX_UINT16 iDst_len);
unsigned char* FCI_RIGHTSTRING(unsigned char* sSrc, MX_UINT16 iSrc_len, MX_UINT16 iCount, unsigned char* sDst, MX_UINT16 iDst_len);
unsigned char* FCI_TOSTRING(MX_SINT32 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len);

MX_UINT8 FCI_TOSTRS16(MX_SINT16 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len);
MX_UINT8 FCI_TOSTRS32(MX_SINT32 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len);
MX_UINT8 FCI_TOSTRU16(MX_UINT16 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len);
MX_UINT8 FCI_TOSTRU32(MX_UINT32 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len);

void FCI_TOLOWER(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len);
void FCI_TOUPPER(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len);
MX_UINT8 FCI_COMPARE(unsigned char* sSrc1, MX_UINT16 iSrc1_len, unsigned char* sSrc2, MX_UINT16 iSrc2_len, MX_UINT8 iNoCase);
unsigned char* FCI_FLOAT_TO_STRING(MX_FLOAT Number, MX_UINT8 Precision, unsigned char* String, MX_UINT16 MSZ_String);
unsigned char* FCI_NUMBER_TO_HEX(MX_UINT32 Number, unsigned char* String, MX_UINT16 MSZ_String);
MX_SINT32 FCI_STRING_TO_INT(unsigned char* String, MX_UINT16 MSZ_String);
MX_FLOAT FCI_STRING_TO_FLOAT(unsigned char* String, MX_UINT16 MSZ_String);


MX_UINT8 FCI_STRREV(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len);
MX_UINT8 FCI_STRMOV(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len);
void FCI_SHEAD(unsigned char* sSrc1, MX_UINT16 iSrc1_len, unsigned char* sSrc2, MX_UINT16 iSrc2_len, unsigned char* sDst, MX_UINT16 iDst_len);
void FCI_SCOPY(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len);

MX_SINT16 FCI_CONTAINS(MX_CHAR *FCL_STRDATA, MX_UINT16 FCLsz_STRDATA, MX_CHAR *FCL_STRMATCH, MX_UINT16 FCLsz_STRMATCH, MX_UINT16 FCL_IDX);
void FCI_SPLITSTRING(MX_CHAR *FCL_STRINGINPUT, MX_UINT16 FCLsz_STRINGINPUT, MX_CHAR *FCL_DELIMITER, MX_UINT16 FCLsz_DELIMITER, MX_UINT16 INDEX, MX_CHAR *FCL_RETVAL, MX_UINT16 FCLsz_RETVAL);

# 4 "C:\Program Files (x86)\Flowcode\Compilers\picv2\pic\include\__size_t.h"
typedef unsigned size_t;

# 7 "C:\Program Files (x86)\Flowcode\Compilers\picv2\pic\include\c90\stdlib.h"
typedef unsigned short wchar_t;

# 15
typedef struct {
int rem;
int quot;
} div_t;
typedef struct {
unsigned rem;
unsigned quot;
} udiv_t;
typedef struct {
long quot;
long rem;
} ldiv_t;
typedef struct {
unsigned long quot;
unsigned long rem;
} uldiv_t;

# 65
extern double atof(const char *);
extern double strtod(const char *, const char **);
extern int atoi(const char *);
extern unsigned xtoi(const char *);
extern long atol(const char *);

# 73
extern long strtol(const char *, char **, int);

extern int rand(void);
extern void srand(unsigned int);
extern void * calloc(size_t, size_t);
extern div_t div(int numer, int denom);
extern udiv_t udiv(unsigned numer, unsigned denom);
extern ldiv_t ldiv(long numer, long denom);
extern uldiv_t uldiv(unsigned long numer,unsigned long denom);

# 85
extern unsigned long _lrotl(unsigned long value, unsigned int shift);
extern unsigned long _lrotr(unsigned long value, unsigned int shift);
extern unsigned int _rotl(unsigned int value, unsigned int shift);
extern unsigned int _rotr(unsigned int value, unsigned int shift);




extern void * malloc(size_t);
extern void free(void *);
extern void * realloc(void *, size_t);

# 104
extern int atexit(void (*)(void));
extern char * getenv(const char *);
extern char ** environ;
extern int system(char *);
extern void qsort(void *, size_t, size_t, int (*)(const void *, const void *));
extern void * bsearch(const void *, void *, size_t, size_t, int(*)(const void *, const void *));
extern int abs(int);
extern long labs(long);

extern char * itoa(char * buf, int val, int base);
extern char * utoa(char * buf, unsigned val, int base);




extern char * ltoa(char * buf, long val, int base);
extern char * ultoa(char * buf, unsigned long val, int base);

extern char * ftoa(float f, int * status);

# 126 "C:\ProgramData\MatrixTSL\FlowcodeV10\CAL\PIC\PIC_CAL_String.c"
MX_UINT8 FCI_GETCHAR(unsigned char* sStr1, MX_UINT16 iStr1_len, MX_UINT16 iPos)
{
if(iPos < iStr1_len)
return sStr1[iPos];
return '\0';
}


MX_UINT16 FCI_GETLENGTH(unsigned char* sStr1, MX_UINT16 iStr1_len)
{
MX_UINT16 tmp;
for (tmp = 0; tmp < iStr1_len; tmp++) if (sStr1[tmp] == 0) break;
return (tmp);
}


unsigned char* FCI_MIDSTRING(unsigned char* sSrc, MX_UINT16 iSrc_len, MX_UINT16 iStart, MX_UINT16 iCount, unsigned char* sDst, MX_UINT16 iDst_len)
{
if (iDst_len == 0) return sDst;
MX_UINT16 idx;
for (idx = 0; idx < iSrc_len; idx++) if (sSrc[idx] == 0) break;

if (iStart >= idx)
{
sDst[0] = '\0';
}
else
{
if ((iStart + iCount) >= idx)
iCount = idx - iStart;
if (iCount > (iDst_len))
iCount = (iDst_len);

for (idx = 0; idx < iCount; idx++)
{
sDst[idx] = sSrc[idx + iStart];
}
if (idx < iDst_len)
{
sDst[idx] = '\0';
}
}
return (sDst);
}


unsigned char* FCI_LEFTSTRING(unsigned char* sSrc, MX_UINT16 iSrc_len, MX_UINT16 iCount, unsigned char* sDst, MX_UINT16 iDst_len)
{
if (iDst_len == 0) return sDst;
MX_UINT16 idx;
for (idx = 0; idx < iSrc_len; idx++) if (sSrc[idx] == 0) break;

if (iCount > idx)
iCount = idx;
if (iCount > (iDst_len))
iCount = (iDst_len);

for (idx = 0; idx < iCount; idx++)
{
sDst[idx] = sSrc[idx];
}

if (idx < iDst_len)
sDst[idx] = '\0';

return (sDst);
}


unsigned char* FCI_RIGHTSTRING(unsigned char* sSrc, MX_UINT16 iSrc_len, MX_UINT16 iCount, unsigned char* sDst, MX_UINT16 iDst_len)
{
if (iDst_len == 0) return sDst;
MX_UINT16 idx;
MX_UINT16 delta;

for (idx = 0; idx < iSrc_len; idx++) if (sSrc[idx] == 0) break;

if (iCount > idx)
iCount = idx;

delta = idx - iCount;

if (iCount > (iDst_len))
iCount = (iDst_len);

for(idx = 0; idx < iCount; idx++)
{
sDst[idx] = sSrc[idx + delta];
}

if (idx < iDst_len)
sDst[idx] = '\0';

return (sDst);
}



MX_UINT8 FCI_TOSTRS16(MX_SINT16 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len)
{
MX_UINT8 tmp1;
MX_SINT16 iSrc = iSrc1;
MX_UINT16 top = 10000;
MX_UINT8 idx = 0;

if (iDst_len == 0) return 0;



if (iSrc < 0)
{
sDst[0] = '-';
idx++;
iSrc = -iSrc;
}

tmp1 = 0;
if (iSrc == 0)
{
tmp1 = 1;
top = 1;
}
while (( idx < iDst_len) && (top > 0))
{
if (((unsigned)iSrc >= top) || (tmp1))
{
tmp1 = (unsigned)iSrc / top;
sDst[idx] = '0' + tmp1;
idx++;
iSrc -= tmp1 * top;
tmp1 = 1;
}
top /= 10;
}

if (idx < iDst_len)
sDst[idx] = '\0';
return (idx);
}


MX_UINT8 FCI_TOSTRS32(MX_SINT32 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len)
{
MX_UINT8 tmp1;
MX_SINT32 iSrc = iSrc1;
MX_UINT32 top = 1000000000;
MX_UINT8 idx = 0;

if (iDst_len == 0) return 0;



if (iSrc < 0)
{
sDst[0] = '-';
idx++;
iSrc = -iSrc;
}

tmp1 = 0;
if (iSrc == 0)
{
tmp1 = 1;
top = 1;
}
while (( idx < iDst_len) && (top > 0))
{
if (((unsigned long)iSrc >= top) || (tmp1))
{
tmp1 = (unsigned long)iSrc / top;
sDst[idx] = '0' + tmp1;
idx++;
iSrc -= tmp1 * top;
tmp1 = 1;
}
top /= 10;
}

if (idx < iDst_len)
sDst[idx] = '\0';
return (idx);
}


MX_UINT8 FCI_TOSTRU16(MX_UINT16 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len)
{
MX_UINT8 tmp1;
MX_UINT16 iSrc = iSrc1;
MX_UINT16 top = 10000;
MX_UINT8 idx = 0;

if (iDst_len == 0) return 0;

tmp1 = 0;
if (iSrc == 0)
{
tmp1 = 1;
top = 1;
}
while (( idx < iDst_len) && (top > 0))
{
if (((unsigned)iSrc >= top) || (tmp1))
{
tmp1 = (unsigned)iSrc / top;
sDst[idx] = '0' + tmp1;
idx++;
iSrc -= tmp1 * top;
tmp1 = 1;
}
top /= 10;
}

if (idx < iDst_len)
sDst[idx] = '\0';
return (idx);
}


MX_UINT8 FCI_TOSTRU32(MX_UINT32 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len)
{
MX_UINT8 tmp1;
MX_UINT32 iSrc = iSrc1;
MX_UINT32 top = 1000000000;
MX_UINT8 idx = 0;

if (iDst_len == 0) return 0;

tmp1 = 0;
if (iSrc == 0)
{
tmp1 = 1;
top = 1;
}
while (( idx < iDst_len) && (top > 0))
{
if (((unsigned long)iSrc >= top) || (tmp1))
{
tmp1 = (unsigned long)iSrc / top;
sDst[idx] = '0' + tmp1;
idx++;
iSrc -= tmp1 * top;
tmp1 = 1;
}
top /= 10;
}

if (idx < iDst_len)
sDst[idx] = '\0';
return (idx);
}



unsigned char* FCI_TOSTRING(MX_SINT32 iSrc1, unsigned char* sDst, MX_UINT16 iDst_len)
{
MX_UINT8 tmp1;

MX_SINT32 iSrc = iSrc1;


unsigned long top = 1000000000;

# 391
MX_UINT8 idx = 0;

if (iDst_len == 0) return sDst;



if (iSrc < 0)
{
sDst[0] = '-';
idx++;
iSrc = -iSrc;
}

tmp1 = 0;
if (iSrc == 0)
{
tmp1 = 1;
top = 1;
}
while (( idx < iDst_len) && (top > 0))
{

if (((unsigned long)iSrc >= top) || (tmp1))

# 417
{

tmp1 = (unsigned long)iSrc / top;

# 423
sDst[idx] = '0' + tmp1;
idx++;
iSrc -= tmp1 * top;
tmp1 = 1;
}
top /= 10;
}

if (idx < iDst_len)
sDst[idx] = '\0';
return (sDst);
}


void FCI_TOLOWER(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len)
{
if (iDst_len == 0) return;
MX_UINT16 idx;
MX_UINT16 ch;

if (iSrc_len < iDst_len) iSrc_len = iDst_len;

for (idx=0; idx<iSrc_len; idx++)
{
ch = sSrc[idx];
if ((ch >= 'A') && (ch <= 'Z'))
{
ch ^= 0x20;
}
sDst[idx] = ch;
if (ch == 0)
{
break;
}
}
if (idx < iDst_len)
sDst[idx] = '\0';
}


void FCI_TOUPPER(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len)
{
if (iDst_len == 0) return;
MX_UINT16 idx;
MX_UINT16 ch;

if (iSrc_len < iDst_len) iSrc_len = iDst_len;

for (idx=0; idx<iSrc_len; idx++)
{
ch = sSrc[idx];
if ((ch >= 'a') && (ch <= 'z'))
{
ch ^= 0x20;
}
sDst[idx] = ch;
if (ch == 0)
{
break;
}
}
if (idx < iDst_len)
sDst[idx] = '\0';
}


MX_UINT8 FCI_COMPARE(unsigned char* sSrc1, MX_UINT16 iSrc1_len, unsigned char* sSrc2, MX_UINT16 iSrc2_len, MX_UINT8 iNoCase)
{
MX_UINT16 idx = 0;
MX_UINT8 ch1, ch2;

while ((idx < iSrc1_len)&&(idx < iSrc2_len))
{
ch1 = sSrc1[idx];
ch2 = sSrc2[idx];

if (iNoCase)
{
if ((ch1 >= 'a') && (ch1 <= 'z'))
ch1 = (ch1 & 0xDF);

if ((ch2 >= 'a') && (ch2 <= 'z'))
ch2 = (ch2 & 0xDF);
}

if (ch2 == 0)
{
if (ch1 == 0)
return (0);
else
return (1);
}
else if (ch1 == 0)
return (255);
else if (ch1 < ch2)
return(255);
else if (ch1 > ch2)
return(1);

++idx;
}


if (iSrc1_len > iSrc2_len)
{
if (sSrc1[idx] == 0)
return (0);
else
return (1);
}
else if (iSrc1_len < iSrc2_len)
{
if (sSrc2[idx] == 0)
return (0);
else
return (255);
}
return (0);
}


unsigned char* FCI_FLOAT_TO_STRING(MX_FLOAT Number, MX_UINT8 Precision, unsigned char* String, MX_UINT16 MSZ_String)
{
MX_SINT32 whole;
MX_UINT8 idx;
MX_UINT8 stringidx = 0;
MX_FLOAT temp = 0.5;
MX_FLOAT real;
MX_UINT8 temp_string[12];


for (idx = 0; idx < Precision; idx++) temp *= 0.1;

if (Number < 0)
{
Number = -Number;
String[stringidx++] = '-';
}
Number += temp;

temp = floor(Number);
whole = (MX_SINT32)temp;

real = Number - temp;

FCI_TOSTRING(whole, temp_string, sizeof(temp_string));

for (idx=0; temp_string[idx]; idx++)
{
if(stringidx < MSZ_String)
{
String[stringidx] = temp_string[idx];
stringidx = stringidx + 1;
}
}

if (Precision > 0)
{
if(stringidx < MSZ_String)
{
String[stringidx] = '.';
stringidx = stringidx + 1;
}

for (idx = 0; idx < Precision; idx++)
{
if (stringidx >= MSZ_String)
break;

real = real * 10;
whole = (MX_SINT32)real;
temp = (MX_FLOAT)whole;
real = real - temp;

String[stringidx] = '0' + whole;
stringidx = stringidx + 1;
}
}

if(stringidx < MSZ_String)
{
String[stringidx] = 0;
}

return String;
}




unsigned char* FCI_NUMBER_TO_HEX(MX_UINT32 Number, unsigned char* String, MX_UINT16 MSZ_String)
{
MX_UINT8 stringidx;
MX_UINT8 idx = 0;
MX_UINT8 temp;
MX_UINT8 digit[8];



MX_UINT32 num = Number;

# 627
String[0] = 0;


if(((Number >> 8) > 0xFF) && (MSZ_String < 10))
return String;

if((Number > 0xFF) && (MSZ_String < 6))
return String;

if((Number <= 0xFF) && (MSZ_String < 4))
return String;


String[0] = '0';
String[1] = 'x';


do
{
temp = num % 16;
num = num >> 4;

if(temp > 9)
{
temp = temp - 10;
digit[idx] = temp + 'A';
}
else
digit[idx] = temp + '0';

idx = idx + 1;
} while (num > 0);


if(idx == 1)
{
digit[1] = '0';
idx = 2;
}


for (stringidx = 2; stringidx < (idx + 2); stringidx++)
String[stringidx] = digit[idx - (stringidx - 1)];


if(stringidx < MSZ_String)
{
String[stringidx] = 0;
}

return String;
}




MX_SINT32 FCI_STRING_TO_INT(unsigned char* String, MX_UINT16 MSZ_String)
{
MX_UINT8 bNegative = 0;
MX_UINT8 idx = 0;
MX_SINT32 RetVal = 0;


while (idx < MSZ_String && (String[idx] != 0) && (String[idx] < '0' || String[idx] > '9'))
{

if(String[idx] == '-')
{
bNegative = 1;
idx = idx + 1;
break;
}
idx = idx + 1;
}


while (idx < MSZ_String && String[idx] >= '0' && String[idx] <= '9')
{

RetVal = (long) RetVal * 10;
RetVal = (long) RetVal + (String[idx] - '0');
idx = idx + 1;
}

if (bNegative)
RetVal = (long) 0 - RetVal;

return RetVal;
}




MX_FLOAT FCI_STRING_TO_FLOAT(unsigned char* String, MX_UINT16 MSZ_String)
{
MX_FLOAT RetVal = 0;
MX_FLOAT real_divider = 1;
MX_UINT32 whole, real;
MX_UINT8 idx = 0;
MX_UINT8 idx2 = 0;
MX_UINT8 offset = 0;
MX_UINT8 bNegative = 0;
MX_UINT8 Comp_String[8];


if(String[0] == '-')
{
bNegative = 1;
offset = 1;
}


for(idx=offset; idx<MSZ_String; idx++)
{
if(String[idx] == '.')
break;
}


whole = FCI_STRING_TO_INT (String, idx);


if(idx == MSZ_String)
{
RetVal = (MX_FLOAT)whole;
return RetVal;
}


offset = idx + 1;
for(idx=offset; idx<MSZ_String; idx++)
{
if(String[idx] >= '0' && String[idx] <= '9')
{
Comp_String[idx - offset] = String[idx];
real_divider = real_divider * 0.1;
}
else
break;
}


real = FCI_STRING_TO_INT (Comp_String, (idx - offset));


RetVal = (MX_FLOAT)real;
RetVal = RetVal * real_divider;
real_divider = (MX_FLOAT)whole;
RetVal = RetVal + real_divider;

if (bNegative)
RetVal = -RetVal;

return RetVal;
}

# 790
MX_UINT8 FCI_STRREV(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len)
{
MX_UINT16 ix, len;
for (len = 0; len < iSrc_len; len++) if (sSrc[len] == 0) break;
if (len > iDst_len)
{
len = iDst_len;
}
ix = len;
while (ix > 0)
{
ix--;
sDst[ix] = sSrc[ix];
}


return len;
}

# 814
MX_UINT8 FCI_STRMOV(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len)
{
MX_UINT16 ix;
ix = 0;
while (ix < iSrc_len && ix < iDst_len && sSrc[ix] != '\0')
{
sDst[ix] = sSrc[ix];
ix++;
}


return ix;
}

# 837
void FCI_SHEAD(unsigned char* sSrc1, MX_UINT16 iSrc1_len, unsigned char* sSrc2, MX_UINT16 iSrc2_len, unsigned char* sDst, MX_UINT16 iDst_len)
{

MX_UINT16 len, strt;

if ((MX_UINT16) sSrc2 == (MX_UINT16) sDst)
{
for (strt = 0; strt < iSrc1_len; strt++) if (sSrc1[strt] == 0) break;
if (strt < iDst_len)
{


for (len = 0; len < iSrc2_len; len++) if (sSrc2[len] == 0) break;
if (len > (iDst_len - strt))
{
len = (iDst_len - strt);
}
iSrc2_len = strt + len;
strt = len;
while (strt > 0)
{
strt--;
iSrc2_len--;
sDst[iSrc2_len] = sSrc2[strt];
}

for (strt = 0; strt < (iSrc1_len) && strt < (iDst_len) && sSrc1[strt] != '\0'; strt++) sDst[strt] = sSrc1[strt];
len += strt;
}
else
{

for (len = 0; len < (iSrc1_len) && len < (iDst_len) && sSrc1[len] != '\0'; len++) sDst[len] = sSrc1[len];
}
}
else
{

for (len = 0; len < (iSrc1_len) && len < (iDst_len) && sSrc1[len] != '\0'; len++) sDst[len] = sSrc1[len];

if (len < iDst_len)
{
unsigned char* temp_sSrc1 = sDst + len;
iSrc1_len = iDst_len - len;
for (strt = 0; strt < (iSrc2_len) && strt < (iSrc1_len) && sSrc2[strt] != '\0'; strt++) temp_sSrc1[strt] = sSrc2[strt];
len += strt;
}
}

if (len < iDst_len)
{
sDst[len] = '\0';
}
}

# 898
void FCI_SCOPY(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDst, MX_UINT16 iDst_len)
{
MX_UINT16 len;


for (len = 0; len < (iSrc_len) && len < (iDst_len) && sSrc[len] != '\0'; len++) sDst[len] = sSrc[len];

if (len < iDst_len)
{
sDst[len] = '\0';
}
}

# 926
MX_SINT16 FCI_CONTAINS(MX_CHAR *FCL_STRDATA, MX_UINT16 FCLsz_STRDATA, MX_CHAR *FCL_STRMATCH, MX_UINT16 FCLsz_STRMATCH, MX_UINT16 FCL_IDX)
{
MX_UINT16 FCL_SUBIDX = (0x0);
MX_UINT16 FCL_LEN;
MX_UINT16 FCL_SUBLEN;
MX_SINT16 FCR_RETVAL = -1;

FCL_LEN = FCI_GETLENGTH(FCL_STRDATA, FCLsz_STRDATA);
FCL_SUBLEN = FCI_GETLENGTH(FCL_STRMATCH, FCLsz_STRMATCH);

while (FCL_IDX < FCL_LEN)
{
if (FCL_STRDATA[FCL_IDX] == FCL_STRMATCH[FCL_SUBIDX])
{
FCL_SUBIDX = FCL_SUBIDX + 1;

if (FCL_SUBIDX == FCL_SUBLEN)
{
FCR_RETVAL = FCL_IDX + 1 - FCL_SUBLEN;
break;
}
}
else
{
if (FCL_SUBIDX)
{
FCL_IDX = FCL_IDX - FCL_SUBIDX;
}
FCL_SUBIDX = 0;
}

FCL_IDX = FCL_IDX + 1;
}

return (FCR_RETVAL);

}

# 975
void FCI_SPLITSTRING(MX_CHAR *FCL_STRINGINPUT, MX_UINT16 FCLsz_STRINGINPUT, MX_CHAR *FCL_DELIMITER, MX_UINT16 FCLsz_DELIMITER, MX_UINT16 FCL_INDEX, MX_CHAR *FCL_RETVAL, MX_UINT16 FCLsz_RETVAL)
{
MX_UINT16 FCL_LEN_DELIM = FCI_GETLENGTH(FCL_DELIMITER, FCLsz_DELIMITER);
MX_UINT16 FCL_START = 0;
MX_UINT16 FCL_END = 0;
FCL_RETVAL[0] = 0;
FCL_INDEX = FCL_INDEX - 1;

while (FCL_INDEX > 0)
{
FCL_START = FCI_CONTAINS(FCL_STRINGINPUT, FCLsz_STRINGINPUT, FCL_DELIMITER, FCLsz_DELIMITER, FCL_START);
if (FCL_START >= 0)
{
FCL_START = FCL_START + FCL_LEN_DELIM;
FCL_INDEX--;
}
else
{
FCL_INDEX = 0;
}
}

if (FCL_START >= 0)
{
FCL_END = FCI_CONTAINS(FCL_STRINGINPUT, FCLsz_STRINGINPUT, FCL_DELIMITER, FCLsz_DELIMITER, FCL_START);

if (FCL_END > 0)
FCI_MIDSTRING(FCL_STRINGINPUT, FCLsz_STRINGINPUT, FCL_START, (FCL_END - FCL_START), FCL_RETVAL, FCLsz_RETVAL);
}
}

# 1020
void FCI_EXPLODETOINTARRAY(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDelimiters, MX_UINT16 iDelimiters_len, MX_UINT8 iMaxCount, MX_SINT16 iArray[], MX_UINT8 pArraySize)
{
int iArrayIdx = 0;
int iStringLen = FCI_GETLENGTH(sSrc, iSrc_len);
MX_CHAR sTemp[20];
int iSourceCharIdx = 0;
int iTempCharIdx = 0;

while ((iSourceCharIdx < iStringLen) && (iTempCharIdx < 20) && (iArrayIdx < iMaxCount) && (iArrayIdx < pArraySize))
{
if (sSrc[iSourceCharIdx] == sDelimiters[0])
{
sTemp[iTempCharIdx] = 0;
iArray[iArrayIdx] = FCI_STRING_TO_INT(sTemp, 20);
iArrayIdx++;
iTempCharIdx = 0;
}
else
{
sTemp[iTempCharIdx] = sSrc[iSourceCharIdx];
iTempCharIdx++;
}

iSourceCharIdx++;
}

if ((iTempCharIdx < 20) && (iArrayIdx < iMaxCount) && (iArrayIdx < pArraySize))
{
sTemp[iTempCharIdx] = 0;
iArray[iArrayIdx] = FCI_STRING_TO_INT(sTemp, 20);
}
}

# 1068
void FCI_EXPLODETOFLOATARRAY(unsigned char* sSrc, MX_UINT16 iSrc_len, unsigned char* sDelimiters, MX_UINT16 iDelimiters_len, MX_UINT8 iMaxCount, MX_FLOAT fArray[], MX_UINT8 iArraySize)
{
int iArrayIdx = 0;
int iStringLen = FCI_GETLENGTH(sSrc, iSrc_len);
MX_CHAR sTemp[20];
int iSourceCharIdx = 0;
int iTempCharIdx = 0;

while ((iSourceCharIdx < iStringLen) && (iTempCharIdx < 20) && (iArrayIdx < iMaxCount) && (iArrayIdx < iArraySize))
{
if (sSrc[iSourceCharIdx] == sDelimiters[0])
{
sTemp[iTempCharIdx] = 0;
fArray[iArrayIdx] = FCI_STRING_TO_FLOAT(sTemp, 20);
iArrayIdx++;
iTempCharIdx = 0;
}
else
{
sTemp[iTempCharIdx] = sSrc[iSourceCharIdx];
iTempCharIdx++;
}

iSourceCharIdx++;
}

if ((iTempCharIdx < 20) && (iArrayIdx < iMaxCount) && (iArrayIdx < iArraySize))
{
sTemp[iTempCharIdx] = 0;
fArray[iArrayIdx] = FCI_STRING_TO_INT(sTemp, 20);
}
}

# 1115
void FCI_IMPLODEFROMFLOATARRAY(MX_FLOAT fArray[], MX_UINT16 iArraySize,
MX_CHAR cDelimiter, MX_UINT8 iMaxCount, MX_UINT8 iPrecision, unsigned char* sReturn, MX_UINT16 iReturn_len)
{
int iArrayIdx = 0;
MX_CHAR sTemp[20];
sReturn[0] = 0;

while ((iArrayIdx < iMaxCount) && (iArrayIdx < iArraySize))
{
if (iArrayIdx != 0)
{
sTemp[0] = cDelimiter;
sTemp[1] = 0;
FCI_SHEAD(sReturn, iReturn_len, sTemp, 1, sReturn, iReturn_len);
}
FCI_FLOAT_TO_STRING(fArray[iArrayIdx], iPrecision, sTemp, 20);
FCI_SHEAD(sReturn, iReturn_len, sTemp, 20, sReturn, iReturn_len);
iArrayIdx++;
}
}

# 44 "C:\ProgramData\MatrixTSL\FlowcodeV10\CAL\PIC\PIC_CAL_Float.c"
char isinf(float f);
char float32_is_signaling_nan(float f);

# 77
MX_SINT32 MX_Map(MX_SINT32 x, MX_SINT32 in_min, MX_SINT32 in_max, MX_SINT32 out_min, MX_SINT32 out_max);
MX_FLOAT MX_Map_Float(MX_FLOAT x, MX_FLOAT in_min, MX_FLOAT in_max, MX_FLOAT out_min, MX_FLOAT out_max);

MX_SINT32 MX_Map(MX_SINT32 x, MX_SINT32 in_min, MX_SINT32 in_max, MX_SINT32 out_min, MX_SINT32 out_max)
{
return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

MX_FLOAT MX_Map_Float(MX_FLOAT x, MX_FLOAT in_min, MX_FLOAT in_max, MX_FLOAT out_min, MX_FLOAT out_max)
{
return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}



char isinf(float f)
{
char* b;
b = (char*)&f;
if ((b[0] == 0) && (b[1] == 0) && (b[2] == 128) && ((b[3] & 127) == 127))
{
return (255);
}
return (0);
}


char float32_is_signaling_nan(float f)
{
char* b;
b = (char*)&f;
if ((b[0] == 255) && (b[1] == 255) && (b[2] == 255) && (b[3] == 255))
{
return (255);
}
return (0);
}

# 127
inline signed long flt_cos_i(unsigned long Rads12)
{
unsigned long x, x2, x4, x6, x8, err;
signed int sgn;

x = Rads12;
if (x > 6433 && x <= 19301)
{
sgn = -1;
}
else
{
sgn = 1;
}
if (x > 12867)
{
x -= 12867;
}
if (x > 6433)
{
x = 12867 - x;
}

x2 = (x * x + 2047) >> 12;
x4 = (x2 * x2) >> 12;
x6 = (x4 * x2) >> 12;
x8 = (x4 * x4) >> 12;

x2 *= 360;
x4 *= 30;
x8 /= 90;
err = 250;
return ((signed long)((2949120L - x2 + x4 - x6 + x8 - err) * sgn) * 7) >> 1;
}

# 175
inline signed long flt_sin_i(unsigned long Rads12)
{
unsigned long x, x2, x3, x5, x7, x9, err;
signed int sgn;

x = Rads12;
if (x > 12867)
{
sgn = -1;
x -= 12867;
}
else
{
sgn = 1;
}
if (x > 6433)
{
x = 12867 - x;
}
x2 = (x * x + 2047) >> 12;
x3 = (x2 * x) >> 12;
x5 = (x3 * x2) >> 12;
x7 = (x5 * x2) >> 12;
x9 = (x7 * x2) >> 12;

x *= 2520;
x3 *= 420;
x5 *= 21;
x9 /= 36;
err = 2048;
return (signed long)(x - x3 + x5 - x7 + x9 + err) * sgn;
}

# 58 "Data_Detector.c"
volatile MX_UINT8 FCV_COUNTER;
volatile MX_BOOL FCV_DATA_IN;

# 67
void main()
{

# 75
(FC_CAL_Port_Out_DDR_10F_x(((1<<5)), (((1)) << (5))));


while (1)
{

FCC_Main_A:
;


FCV_DATA_IN = (FC_CAL_Port_In_DDR_10F_x(((1<<0)), (0)));


if (FCV_DATA_IN == 0)
{


(FC_CAL_Port_Out_DDR_10F_x(((1<<5)), (((0)) << (5))));


while (1)
{

FCV_DATA_IN = (FC_CAL_Port_In_DDR_10F_x(((1<<0)), (0)));


if (FCV_DATA_IN == 1)
{



FCV_COUNTER = FCV_COUNTER + 1;


delay_us((100));


if (FCV_COUNTER > 80)
{

# 119
(FC_CAL_Port_Out_DDR_10F_x(((1<<5)), (((1)) << (5))));



FCV_COUNTER = 0;


goto FCC_Main_A;



}

} else {



FCV_COUNTER = 0;

}

}



}

}

mainendloop: goto mainendloop;
}

